var app = {
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    /**
     * deviceready Event Handler
     * enable the button "verify" or going to the terms and conditions page
     */
    onDeviceReady: function() {

		$('#btn_verificar').button('enable');
		localStorage.setItem("usuario", "FreemiumV");
		localStorage.setItem("clave", "Free");
		localStorage.setItem("version","Free");

    	if(localStorage.getItem("agree") != "SI") { 
			window.location.href="#terminosycondiciones";
		} else {
         	var scanned = app.scan();
		}
    },
    /**
     * here is an example for scanning a barcode...
     *
     */
    scan: function() {
        var scanner = cordova.require("cordova/plugin/BarcodeScanner");
        scanner.scan(
                function (result) {
                	app.verificar(result.text);
                },
                function (error) {
                	navigator.notification.alert(
					    'Error leyendo el código QR!',     // mensaje (message)
					    alertDismissed,         	// función 'callback' (alertCallback)
					    'Error',           		 	// titulo (title)
					    'OK'                		// nombre del botón (buttonName)
					);
                }
        );
    },
    /**
     * Verifica la url que escanea
     *
     */
    verificar: function(url) {
        if(!isUrlLeidaValida(url)){
			navigator.notification.alert(
			    'El código QR leido no pertenece a Verifique.se!. '+ localStorage.getItem("mensajeUrlValida"),     // mensaje (message)
			    alertDismissed,         // función 'callback' (alertCallback)
			    'Error',            	// titulo (title)
			    'OK'                	// nombre del botón (buttonName)
			);
		}else{
			getURLPrivada(url);
		}
    },
    /**
     * Open pdf
     *
     */
     openpdf:function(urlOpen){
     	switch(urlOpen){
     		case "EI":
				navigator.notification.alert(
				    'Error interno en Verifique.se.  Favor comunicarlo a soporte@verifique.se',     // mensaje (message)
				    alertDismissed,         // función 'callback' (alertCallback)
				    'Error',            // titulo (title)
				    'OK'                // nombre del botón (buttonName)
				);
			break;
			case "NA":
				navigator.notification.alert(
				    'Autenticación equivocada en Verifique.se.!',     // mensaje (message)
				    alertDismissed,         // función 'callback' (alertCallback)
				    'Error',            // titulo (title)
				    'OK'                // nombre del botón (buttonName)
				);
			break;
			case "NE":
				navigator.notification.alert(
				    'El QR Code leido no corresponde a un documento de Verifique.se.!',     // mensaje (message)
				    alertDismissed,         // función 'callback' (alertCallback)
				    'Notificación',            // titulo (title)
				    'OK'                // nombre del botón (buttonName)
				);
			break;
			case "II":
				navigator.notification.alert(
				    'El Sistema está presentando problemas.  Por favor reportarlo a soporte@verifique.se',     // mensaje (message)
				    alertDismissed,         // función 'callback' (alertCallback)
				    'Notificación',            // titulo (title)
				    'OK'                // nombre del botón (buttonName)
				);
			break;
			case "TI":
				navigator.notification.alert(
				    'El Sistema está presentando problemas de Autenticación de Token.  Por favor reportarlo a soporte@verifique.se',     // mensaje (message)
				    alertDismissed,         // función 'callback' (alertCallback)
				    'Notificación',            // titulo (title)
				    'OK'                // nombre del botón (buttonName)
				);
			break;
			default:
				if(urlOpen != ""){
					try{
						if( navigator.app ) // Android
				       		navigator.app.loadUrl(urlOpen, {openExternal : true});
						else // iOS and others
							window.open( urlOpen, "_system" );
					}catch(err){
						navigator.notification.alert(
						    'Error al abrir el archivo '+urlOpen+'. Error:'+err.message,     // mensaje (message)
						    alertDismissed,         // función 'callback' (alertCallback)
						    'Error',            // titulo (title)
						    'OK'                // nombre del botón (buttonName)
						);
					}
				}else{
					navigator.notification.alert(
					    'Archivo no encontrado!',     // mensaje (message)
					    alertDismissed,         	// función 'callback' (alertCallback)
					    'Error de conexión',        // titulo (title)
					    'OK'                		// nombre del botón (buttonName)
					);
				}
			break;
     	}
     }
};
	
	function alertDismissed(){
		// no hace nada
	}
	function cerrarAplicacion(){
	    if(navigator.app){
          navigator.app.exitApp();
        }else if(navigator.device){
          navigator.device.exitApp();
        }		  
	  }
	
	function agree_SI(){
		localStorage.setItem("agree","SI");
		window.location="#inicio";
	}
	 
	function agree_NO(){
		localStorage.removeItem("agree");
       	localStorage.setItem("agree","NO");
	    cerrarAplicacion();
	}
	function confirmaCerrarAplicacion() {
        navigator.notification.confirm(
            '¿Realmente desea salir?',  // message
            exitFromApp,             	// callback to invoke with index of button pressed
            'Salir',           		 	// title
            'Cancelar,Aceptar'       	// buttonLabels
        );
    }
    
    function exitFromApp(buttonIndex) {
      	if (buttonIndex == 2){
       		cerrarAplicacion();
    	}
    }

	function getURLPrivada(urlPublica){
		var urlPOSTPrivada = "http://a.verifique.se/v";
		var mensaje = "m=l&u="+localStorage.getItem("usuario")+"&p="+localStorage.getItem("clave")+"&l=" + encodeURIComponent(urlPublica);
		$.ajax({
			type       : "POST",
			url        : urlPOSTPrivada,
			crossDomain: true,
			beforeSend : function() {$.mobile.loading( 'show', {text: 'Loading',textVisible: true,theme: 'a',html: ""});},
			complete   : function() {$.mobile.loading('hide');},
			data       : {m : 'l', u : localStorage.getItem("usuario"), p : localStorage.getItem("clave"), l : encodeURIComponent(urlPublica) },
			dataType   : 'html',
			success    : app.openpdf,
			error      : problemaGetURLPrivada
		});
		return false;
	}


	function llegadaURLPrivada(respuesta){
		localStorage.URLPrivada = respuesta;
		localStorage.respuesta = "OK";
		return false;
	}
	
	function problemaGetURLPrivada(responseData, textStatus, errorThrown){
		navigator.notification.alert(
		    'Verifique su acceso a internet o comuniquese con soporte@verifique.se',     // mensaje (message)
		    alertDismissed,         	// función 'callback' (alertCallback)
		    'Error de conexión',        // titulo (title)
		    'OK'                		// nombre del botón (buttonName)
		);

	}
		
	function isCodigoValido(codigo){
		//patt=/[a-xA-Z0-9]{6}/g;
		//return patt.test(codigo);
		return true;
	}
		
	function isUrlLeidaValida(url){
		localStorage.setItem("mensajeUrlValida", "iniciando");
		var validada = true;
		validada &= ! ("" == url);
		if (!validada){
			 localStorage.setItem("mensajeUrlValida", "url no leida. vacia.");
			 return false;
		}
		validada &= url.length >= 28;
		if (!validada){
			 localStorage.setItem("mensajeUrlValida", "longitud incompleta");
			 return false;
		}
		validada &= (url.substring(0,4).toLowerCase() == "http"  && url.length == 28);
		if (!validada){
			 localStorage.setItem("mensajeUrlValida", "verificación http o https con longitud.");
			 return false;
		}
		validada &= url.substring(7,21).toLowerCase() == "a.verifique.se";
		if (!validada){
			 localStorage.setItem("mensajeUrlValida", "nombre del host de verifique.se");
			 return false;
		}
		validada &= isCodigoValido(url.substring(22,28).toLowerCase());
		if (!validada){
			 localStorage.setItem("mensajeUrlValida", "6 caracteres del documento.");
			 return false;
		}
		return true;
	}